#!/usr/bin/env bash
#
# owtf is an OWASP+PTES-focused try to unite great tools and facilitate pen testing
# Copyright (c) 2011, Abraham Aranguren <name.surname@gmail.com> Twitter: @7a_ http://7-a.org
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# * Redistributions of source code must retain the above copyright 
# notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# * Neither the name of the copyright owner nor the
# names of its contributors may be used to endorse or promote products
# derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

if [ $# -ne 2 ]; then
	echo "Syntax: $0 <ResourceTypePrefix> <grep pattern>"
	exit
fi

PREFIX=$1
GREP=$2

if [ ! -f msfcli_output.txt ]; then
	echo "[*] Getting msfcli information .."
	/pentest/exploits/framework/msfcli  > msfcli_output.txt
fi

categories=""
subcategories=""
for exploit in $(sed 's/^  *//g' msfcli_output.txt | sed 's/      */#/g'|grep $GREP|sed 's/ /@@@/g'); do
	#echo "exploit=$exploit"
	module=$(echo $exploit|cut -f1 -d#)
	category=$(echo $module|cut -f2 -d/|tr '[:lower:]' '[:upper:]') 
	categories="$categories, '$category'"
	subcategory=$(echo $module|cut -f3 -d/|tr '[:lower:]' '[:upper:]') 
	subcategories="$subcategories, '$subcategory'"
	descrip=$(echo $exploit|cut -f2 -d#|sed 's/@@@/ /g')
	echo "${PREFIX}_${category}_${subcategory}_____${descrip}_____. @@@FRAMEWORK_DIR@@@/scripts/setrubyenv.sh 1.8; @@@TOOL_METASPLOIT_DIR@@@/msfcli $module RHOST=@@@_RHOST@@@ RPORT=@@@_RPORT@@@ E"
done

echo "Categories:"
echo $categories
echo
echo "Subcategories:"
echo $subcategories

#LaunchExploit_LINUX_FTP_____ProFTPD 1.2 - 1.3.0 sreplace Buffer Overflow (Linux)_____ . @@@FRAMEWORK_DIR@@@/scripts/setrubyenv.sh 1.8; @@@TOOL_METASPLOIT_DIR@@@/msfcli 
#RHOST=@@@_RHOST@@@ RPORT=@@@_RPORT@@@ E
